import { NgZone } from '@angular/core';
import { GridsterComponentInterface } from './gridster.interface';
import { GridsterItemComponentInterface } from './gridsterItem.interface';
import { GridsterPush } from './gridsterPush.service';
import { GridsterPushResize } from './gridsterPushResize.service';
import { GridsterResizeEventType, MouseEvent2 } from './gridsterResizeEventType.interface';
export declare class GridsterResizable {
    private zone;
    gridsterItem: GridsterItemComponentInterface;
    gridster: GridsterComponentInterface;
    lastMouse: {
        clientX: number;
        clientY: number;
    };
    itemBackup: number[];
    resizeEventScrollType: GridsterResizeEventType;
    directionFunction: (e: {
        clientX: number;
        clientY: number;
    }) => void;
    dragFunction: (event: MouseEvent) => void;
    dragStopFunction: (event: MouseEvent2) => void;
    resizeEnabled: boolean;
    mousemove: () => void;
    mouseup: () => void;
    mouseleave: () => void;
    cancelOnBlur: () => void;
    touchmove: () => void;
    touchend: () => void;
    touchcancel: () => void;
    push: GridsterPush;
    pushResize: GridsterPushResize;
    minHeight: number;
    minWidth: number;
    offsetTop: number;
    offsetLeft: number;
    diffTop: number;
    diffLeft: number;
    diffRight: number;
    diffBottom: number;
    margin: number;
    originalClientX: number;
    originalClientY: number;
    top: number;
    left: number;
    bottom: number;
    right: number;
    width: number;
    height: number;
    newPosition: number;
    constructor(gridsterItem: GridsterItemComponentInterface, gridster: GridsterComponentInterface, zone: NgZone);
    destroy(): void;
    dragStart(e: MouseEvent2): void;
    dragMove(e: MouseEvent): void;
    dragStop(e: MouseEvent): void;
    cancelResize(): void;
    makeResize(): void;
    handleN(e: MouseEvent): void;
    handleW(e: MouseEvent): void;
    handleS(e: MouseEvent): void;
    handleE(e: MouseEvent): void;
    handleNW(e: MouseEvent): void;
    handleNE(e: MouseEvent): void;
    handleSW(e: MouseEvent): void;
    handleSE(e: MouseEvent): void;
    toggle(): void;
    dragStartDelay(e: MouseEvent | TouchEvent): void;
    setItemTop(top: number): void;
    setItemLeft(left: number): void;
    setItemHeight(height: number): void;
    setItemWidth(width: number): void;
}
